/*
 * $Id: 
 */
#define AROS_ALMOST_COMPATIBLE
#include "global.h"
#include <proto/iffparse.h>
#include <string.h>
#include <ctype.h>

#include <exec/execbase.h>
#include <exec/rawfmt.h>

#define DEBUG 0
#include <aros/debug.h>

#define	LOGINCMD	 "login -f %s"
#define	LOGINCMD_GUI "login -g"

#define ARGS "LOGIN,ASKONBOOT/S,ASKONSCREENSAVER/S"

struct Args
{
	STRPTR Login;
	ULONG  AskonBoot;
	ULONG  AskOnScreenSaver;
};

void LoadUserPrefs(char *filename)
{
	D(bug("IPrefs: UserPrefs <%s>\n",filename));

	if (CheckForNetstack())
	{
		BPTR MyFile;

		if ((MyFile = Open("ENV:Sys/user.prefs", MODE_OLDFILE)))
		{
			struct Args		args;
			BPTR		OldFile;
			struct RDArgs rda;
			struct RDArgs *rda1;

			memset(&rda,0,sizeof(struct RDArgs));

			OldFile = Input();
			SelectInput(MyFile);
			rda.RDA_Flags = RDAF_NOPROMPT | RDAF_STDIN;

			memset(&args,0,sizeof(args));

			if ((rda1 = ReadArgs(ARGS, (LONG *)&args, &rda)))
			{
				if (args.Login && *args.Login)
				{
					int len = strlen(args.Login);
					char *login = AllocVecTaskPooled(len + 1);
					
					if (login)
					{
						int i;
						ULONG l = 0;

						strcpy(login, args.Login);

						for (i = 0; i < len; i++)
						{
							if (login[i] == '`' ||
							    login[i] < ' ' ||
							    login[i] == 0x9b)
							{
								login[i] = ' ';
							}
						}

						NewRawDoFmt(LOGINCMD, (APTR)RAWFMTFUNC_COUNT, (STRPTR)&l, login);
						
						if (l > 0)
						{
							char *c = AllocVecTaskPooled(l);
							
							if (c)
							{
								BPTR ifh, ofh;
								NewRawDoFmt(LOGINCMD, (APTR)RAWFMTFUNC_STRING, c, login);
								
								ifh = Open("NIL:", MODE_OLDFILE);
								ofh = Open("NIL:", MODE_NEWFILE);
								if (ifh && ofh)
								{
									if (SystemTags(c,
												   SYS_Asynch, TRUE,
												   SYS_Input,  ifh,
												   SYS_Output, ofh,
												   TAG_END) != -1)
									{
										ifh = 0;
										ofh = 0;
									}
									else
									{
										D(bug("IPrefs: system error %ld\n",IoErr()));
									}
								}
								else
								{
									D(bug("IPrefs: nil: open error %ld\n",IoErr()));
								}

								if (ofh)
								{
									Close(ofh);
								}

								if (ifh)
								{
									Close(ifh);
								}

								FreeVecTaskPooled(c);
							}
						}
						
						FreeVecTaskPooled(login);
					}
				}

				FreeArgs(rda1);
			}

			SelectInput(OldFile);
			Close(MyFile);
		}
	}
	else
	{
		D(bug("IPrefs: NetStack disabled\n"));
	}
}
